<?php
class ClickAndCallPro extends WP_Widget{
	
	function ClickAndCallPro() {
		$widget_ops = array( 
			'classname' => 'click-and-call-pro',
			'description' => 'Add click to call phone links in your sidebar.'
		);
		
		parent::WP_Widget('click-and-call-pro-widget', 'Click and Call Pro', $widget_ops);
	}

	function form($instance) {
		$title = esc_attr($instance['title']);
        ?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
		</p>
		<?php 
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
        return $instance;
	}

	function widget($args, $instance) {
		global $phone_contacts;
		global $plugin_path;
		$icon_size = get_option( 'ccpro_icon_size' );
		extract( $args );
        $title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
        ?>
			<?php echo $before_widget; ?>
				<?php if ( $title )
					echo $before_title . $title . $after_title; ?>
                <ul class="ccpro_links_container" style="width:100%; text-align:center;">     
				<?php foreach($phone_contacts as $slug => $name):?>
					<?php $ccpro_link = get_option('ccpro_'.$slug);?>
                    <li class="telephone" style="width:40%; text-align:center;  display: inline-table;">
					<?php if ( !empty( $ccpro_link ) ):?>
						<a href="tel:<?php echo $ccpro_link;?>" rel="nofollow"><img src="<?php echo $plugin_path;?>/icons/<?php echo $icon_size;?>/telephone.png" title="<?php echo $name;?>" alt="<?php echo $name;?>" /><br />Call from Phone</a>
					<?php endif;?>
                    </li>
				<?php endforeach;?>
                
                				<?php foreach($phone_contacts as $slug => $name):?>
					<?php $ccpro_link = get_option('ccpro_'.$slug);?>
                    <li class="telephone" style="width:40%; text-align:center;  display: inline-table;">
					<?php if ( !empty( $ccpro_link ) ):?>
						<a href="callto:<?php echo $ccpro_link;?>" rel="nofollow"><img src="<?php echo $plugin_path;?>/icons/<?php echo $icon_size;?>/skype.png" title="<?php echo $name;?>" alt="<?php echo $name;?>" /><br />Call from Skype</a>
					<?php endif;?>
                    </li></ul>
				<?php endforeach;?>
                
                
				<?php if(get_option('ccpro_display_credit')):?>
					<br /><a style="font-size: 0.8em;" href="http://www.solomopro.com/plugins/click-and-call-pro/">Powered by Click and Call Pro</a>
				<?php endif;?>

			<?php echo $after_widget; ?>

        <?php
	}

}
add_action('widgets_init', create_function('', 'return register_widget("ClickAndCallPro");'));
?>
