// ###########################
// ############" START Comment

jQuery('#openCloseAddComment').live('click', function(event) {
	event.preventDefault();
	
	var itemBox = jQuery(this).closest('#itemBox');
	
	if (jQuery('#domAddCommentBox', itemBox).css('display') == 'none') {
		jQuery('#domAddCommentBox', itemBox).css('display','block');
		enableAddCommentBox(itemBox);
	}
	else {
		jQuery('#domAddCommentBox', itemBox).css('display','none');
	}
});

jQuery('#showAllComments').live('click', function(event) {
	event.preventDefault();
	var itemBox = jQuery(this).closest('#itemBox');
	var item_id = itemBox.attr('value');
	
	var nb_comments = ybComment_getCommentCountFromDom(item_id);
	
	var criteria = {"resourceid":item_id, "commentCount":nb_comments};
	ybComment_displayComments(criteria);
});

jQuery('.showAllCommentsPagination').live('click', function(event) {
	event.preventDefault();
	var itemBox = jQuery(this).closest('#itemBox');
	var item_id = itemBox.attr('value');
	var url = jQuery(this).attr('id');
	var criteria = {"resourceid":item_id};
	ybComment_displayComments(criteria, url);
});

jQuery('#hideAllComments').live('click', function(event) {
	event.preventDefault();
	var itemBox = jQuery(this).closest('#itemBox');
	var item_id = itemBox.attr('value');
	var nb_comments = ybComment_getCommentCountFromDom(item_id);
	var criteria = {"resourceid":item_id, "collapse":1, "commentCount":nb_comments};
	ybComment_displayComments(criteria);
});

function ybComment_getCommentCountFromDom(item_id) {
	var commentCountDom = 'commentCount_' + item_id;
	var commentCount = jQuery('body').data(commentCountDom);
	if(commentCount==null || commentCount=='undefined') {
		var commentCount = jQuery('#comments_'+item_id).attr("count");
	}
	return commentCount;
}

function ybComment_decrementCommentCount(item_id) {
	var commentCount = ybComment_getCommentCountFromDom(item_id);
	commentCount--;
	var commentCountDom = 'commentCount_' + item_id;
	jQuery('body').data(commentCountDom, commentCount);
}

function ybComment_incrementCommentCount(item_id) {
	var commentCount = ybComment_getCommentCountFromDom(item_id);
	commentCount++;
	var commentCountDom = 'commentCount_' + item_id;
	jQuery('body').data(commentCountDom, commentCount);
}

function ybComment_displayComments(criteria, url) {
	criteria.dom = 'comments_'+criteria.resourceid;
	var dom = criteria.dom;
	if(url===undefined) url='';
	
	var img = '<img src="' + Fb_wpress_pages.plugin_url + 'include/fb/include/graph/icons/ajax-loader.gif">';
	jQuery('#'+dom).append(' '+img);
	
	criteria = JSON.stringify(criteria);
	jQuery.ajax({
	  type: 'POST',
	  url: Fb_wpress_pages.ajaxurl,
	  data: 'action=fb_wpress_pages_listener&method=display_comments&criteria=' + criteria + '&url=' + url,
	  success: function(msg){
	  	if(msg=='') jQuery('#'+dom).css('padding-top','0px');
	  	jQuery('#'+dom).html(msg);
	  	jQuery('.prettyDate').prettyDate();
	  }
	});
}

function enableAddCommentBox(itemBox) {
	var domComment = jQuery('#domAddComment', itemBox);
	var domPicture = jQuery('#domAddCommentPicture', itemBox);
	var domSubmit = jQuery('#domAddCommentSubmit', itemBox);
	
	if(domComment.val()=='' || domComment.val()=='Write a comment...') {
		domComment.val('');
		domComment.css('color','black');
		domComment.css('height','50px');
		domComment.focus();
		domPicture.css('display','block');
		domPicture.css('width','2px');
		domPicture.css('padding-right','8px');
		domSubmit.css('display','block');
	}
}

function hideAddCommentBox(itemBox) {
	var domAddCommentBox = jQuery('#domAddCommentBox', itemBox);
	var domComment = jQuery('#domAddComment', itemBox);
	var domSubmit = jQuery('#domAddCommentSubmit', itemBox);
	var domSubmitBtn = jQuery('#domAddCommentSubmitBtn', itemBox);
	
	domAddCommentBox.css('display','none');
	domComment.removeAttr('disabled');
	domSubmitBtn.removeAttr('disabled');
	domComment.val('');
	domSubmitBtn.removeAttr('disabled');
}

jQuery('#addCommentCancel').live('click', function(event) {
	event.preventDefault();
	var itemBox = jQuery(this).closest('#itemBox');
	hideAddCommentBox(itemBox);
});

jQuery('#domAddCommentSubmitBtn').live('click', function(event) {
	event.preventDefault();
	var itemBox = jQuery(this).closest('#itemBox');
	var post_id = itemBox.attr('value');
	var comment = jQuery('#domAddComment', itemBox).val();
	fb_addComment(post_id,comment,itemBox);
});

// #########################
// ############" END Comment