<?php

class Pricing_wpress_db {
	
	var $wpdb;
	var $price_table_name;
	
	function Pricing_wpress_db() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->price_table_name = $wpdb->prefix.'pricing_wpress';
	}
	
	//create the pricing table
	function create_pricing_table() {
		$sql = "CREATE TABLE IF NOT EXISTS ".$this->price_table_name." (
		`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
		`name` varchar(100) NOT NULL,
		`pricing_table` TEXT NOT NULL
		) ENGINE = MYISAM ;";
		$this->wpdb->query($sql);
	}
	
	function delete_pricing_table($id) {
		if($id!='') {
			$sql = "DELETE FROM $this->price_table_name WHERE id='$id'";
			$this->wpdb->query($this->wpdb->prepare($sql));
		}
	}
	
	function get_pricing_tables($criteria=array()) {
		$id = $criteria['id'];
		
		$sql = "SELECT *
		FROM $this->price_table_name
		WHERE 1";
		
		if($id!='') $sql .= " AND id='$id'";
		
		$sql .= ' ORDER BY id DESC';
		
		//echo $sql;
		$result = $this->wpdb->get_results($sql, 'ARRAY_A');
		return $result;
	}
	
	function add_pricing_table($criteria=array()) {
		$name = $criteria['name'];
		$nb_columns = $criteria['nb_columns'];
		$nb_lines = $criteria['nb_lines'];
		$line_height = $criteria['line_height'];
		$columns_width = $criteria['columns_width'];
		$caption_columns_width = $criteria['caption_columns_width'];
		$currency = $criteria['currency'];
		$caption_column_state = $criteria['caption_column_state'];
		
		$pricing_table['nb_columns'] = $nb_columns;
		$pricing_table['nb_lines'] = $nb_lines;
		$pricing_table['line_height'] = $line_height;
		$pricing_table['columns_width'] = $columns_width;
		$pricing_table['caption_columns_width'] = $caption_columns_width;
		$pricing_table['currency'] = $currency;
		$pricing_table['caption_column_state'] = $caption_column_state;
		
		$pt1 = new Pricing_wpress();
		$structure = $pt1->format_table_structure($pricing_table);
		
		//print_r($structure);
		
		$pricing_table = "{".$structure."}";
		
		$sql = "INSERT INTO $this->price_table_name (name, pricing_table) VALUES ('$name', '$pricing_table')";
		
		$result = $this->wpdb->query($this->wpdb->prepare($sql));
		return $this->wpdb->insert_id;
	}
	
	function update_pricing_table_structure($criteria=array(), $id) {
		$name = $criteria['name'];
		$nb_columns = $criteria['nb_columns'];
		$nb_lines = $criteria['nb_lines'];
		$line_height = $criteria['line_height'];
		$columns_width = $criteria['columns_width'];
		$caption_columns_width = $criteria['caption_columns_width'];
		$currency = $criteria['currency'];
		$caption_column_state = $criteria['caption_column_state'];
		
		$updated_structure['nb_columns'] = $nb_columns;
		$updated_structure['nb_lines'] = $nb_lines;
		$updated_structure['line_height'] = $line_height;
		$updated_structure['columns_width'] = $columns_width;
		$updated_structure['caption_columns_width'] = $caption_columns_width;
		$updated_structure['currency'] = $currency;
		$updated_structure['caption_column_state'] = $caption_column_state;
		
		$t1 = $this->get_pricing_tables(array('id'=>$id));
		
		if(count($t1)>0) {
			$pricing_table = $t1[0]['pricing_table'];
			$pricing_table = json_decode($pricing_table,true);
			
			$pt1 = new Pricing_wpress();
			$structure = $pt1->format_table_structure($updated_structure);
			$content = $pt1->format_table_content($pricing_table['content'], $nb_columns, $nb_lines);
			
			$pricing_table = "{".$structure.",".$content."}";
			
			$sql = "UPDATE $this->price_table_name SET name='$name', pricing_table='$pricing_table' WHERE id='$id'";
			$this->wpdb->query($this->wpdb->prepare($sql));
		}
	}
	
	function update_pricing_table_content($criteria=array(), $id) {
		$table_content = $criteria['table_content']; //table content
		
		$t1 = $this->get_pricing_tables(array('id'=>$id));
		
		if(count($t1)>0) {
			$db_pricing_table = $t1[0]['pricing_table'];
			$db_pricing_table = json_decode($db_pricing_table,true);
			
			//print_r($pricing_table);
			
			$pt1 = new Pricing_wpress();
			$table_structure = $pt1->format_table_structure($db_pricing_table);
			
			$pricing_table = "{".$table_structure.",".$table_content."}";
			
			//print_r($pricing_table);
			
			$sql = "UPDATE $this->price_table_name SET pricing_table='$pricing_table' WHERE id='$id'";
			$this->wpdb->query($this->wpdb->prepare($sql));
		}
	}
	
}

new Pricing_wpress_db();

?>
