<?php 
/**
 * cr_whlog.php
 *
 * main functions of whlog plugin
 *
 */

function whlog_get_plugin_header($name)
{
	$html=file_get_contents(WP_CONTENT_DIR.'/plugins/'.plugin_basename(dirname(__FILE__))."/index.php");
	$html=explode( '*/',$html);
	$html=$html[0];
	$html=explode(' *',$html);
	foreach($html as $htm)
	{
			if(strstr($htm,$name))
			{
					$st=str_replace($name.':','',$htm);
					return $st;
					
			}
	}
	
}

function whlog_get_themes()
{
	 $data=array();
	 $dirname= WP_CONTENT_DIR.'/plugins/'.plugin_basename(dirname(__FILE__))."/themes";
     if (is_dir($dirname))
        $dir_handle = @opendir($dirname);
	else
   		return NULL;
     while($file = readdir($dir_handle)) {
         if ($file != "." && $file != ".." ) {
             if (is_dir($dirname."/".$file))
                 $data[]=$file;
             			          
         }
     }
		 
     return $data;
}
function whlog_get_values()
{
	global $whlog_config;

	$whlog_config['skin']  	= get_option( 'whlog_skin' );
	$whlog_config['copy']  	= get_option( 'whlog_copy' );	
	$whlog_config['logo'] 	= get_option( 'whlog_logo' );
	$whlog_config['logo_url'] 	= get_option( 'whlog_logo_url' );
	$whlog_config['logo_width'] 	= get_option( 'whlog_logo_width' );
	$whlog_config['logo_height']  = get_option( 'whlog_logo_height' );
	$whlog_config['remove']   = get_option( 'whlog_remove' );
	$whlog_config['shaker']   = get_option( 'whlog_shaker' );
}

/**
 * Remove the shaker effect on login error and print the theme stylesheet
 */
function whlog_theme_head()
{
	global $whlog_config;
	
	remove_action( 'login_head', 'wp_shake_js', 12 );

	print '<script type="text/javascript" src="'. $whlog_config['path'] .'/js/jquery-1.5.2.min.js"></script>' . "\n\r";
	print '<script type="text/javascript" src="'. $whlog_config['path'] .'/js/whlog-common.js"></script>' . "\n\r";
	if( $whlog_config['shaker'] ){
		print '<script type="text/javascript" src="'. $whlog_config['path'] .'/js/shaker.js"></script>' . "\n\r";
	}

	print '<link rel="stylesheet" href="'. $whlog_config['path'] .'/css/common.css" media="all" />';

	print '<link rel="stylesheet" href="'. $whlog_config['path'] .'/themes/'. $whlog_config['skin'] .'/screen.css" media="all" />';

	
	if( $whlog_config['logo'] ){
		
		$custom_width = $whlog_config['logo_width']
					  ? 'width: ' . $whlog_config['logo_width'] . 'px!important; left: -'. ceil( $whlog_config['logo_width'] / 2 ) . 'px!important;'
					  : '';

		$custom_height = $whlog_config['logo_height']
					   ? 'height: ' . $whlog_config['logo_height'] . 'px!important; margin-top: '. ceil( $whlog_config['height'] / 2 ) . 'px!important;'
					   : '';
		
		
		print '<style type="text/css">';
		print '#login h1 a {background: url( img/bg-logo-wp.png ) no-repeat;}';
		print '</style>';
		print '<div style="text-align: center; margin-top:100px;">';
		print '<a href="'. $whlog_config['logo_url'] .'" target="_blank">';
		print '<img src="'. $whlog_config['logo'] .'" border="0" align="middle" />';
		print '</a></div>';
	}
}

/**
 * Add a customizable copyright message to the login screen
 */
function whlog_theme_foot()
{
	global $whlog_config;
	
	if( $whlog_config['copy'] && $whlog_config['skin']  && $whlog_config['skin'] != 'default' )
		print '<div id="custom-copy">'. $whlog_config['copy'] .'</div>';
}

/**
 * Change the default url of the login screen logo
 */
function whlog_logo_url()
{
	global $whlog_config;
	
	return $whlog_config['logo_url']
		 ? $whlog_config['logo_url']
		 : $whlog_config['logo_url'];
}

?>
