<?php
/*
Plugin Name: Facebook WPress Pages
Plugin URI: http://yougapi.com/products/wp/facebook_pages/
Description: This plugin let you integrate Facebook pages into your blog posts or pages.
Version: 1.1
Author: Yougapi Technology LLC
Author URI: http://yougapi.com
*/

define(FACEBOOK_WPRESS_PAGES_SETTINGS, 'facebook_wpress_pages_settings');

require_once dirname( __FILE__ ).'/include/wpress_framework/WPress_framework.php';
require_once dirname( __FILE__ ).'/include/fb/include/webzone.php';
require_once dirname( __FILE__ ).'/facebook_wpress_pages_display.php';

if(is_admin()) {
	require_once dirname( __FILE__ ).'/facebook_wpress_pages_settings.php';
}

class Facebook_wpress_pages {
	
	function Facebook_wpress_pages() {
		add_action('wp_footer', array(__CLASS__, 'add_onload'));
		//shortcodes
		add_shortcode( 'fb_wpress_page', array(__CLASS__, 'display_fb_page') );
		//AJAX
		add_action( 'wp_ajax_nopriv_fb_wpress_pages_listener', array(__CLASS__, 'fb_wpress_pages_listener') );
		add_action( 'wp_ajax_fb_wpress_pages_listener', array(__CLASS__, 'fb_wpress_pages_listener') );
	}
	
	function add_js_scripts() {
		//wp_enqueue_script( 'facebook_wpress_ajax', plugin_dir_url( __FILE__ ) . 'ajax.js', array( 'jquery' ) );
		//wp_localize_script( 'facebook_wpress_ajax', 'MyAjax', array( 'ajaxurl' => admin_url('admin-ajax.php') ) );
	}
	
	function display_fb_page($atts, $content = null, $code) {
		extract(shortcode_atts(array(
		'id' => 'id',
		), $atts));
		
		$fd1 = new Facebook_wpress_pages_display();
		$display = $fd1->get_fb_page_display($id);
		
		return '<p>'.$display.'</p>';
	}
	
	function add_onload() {
		
		echo '<script>
		/* <![CDATA[ */
		var Fb_wpress_pages = {
			"ajaxurl": "'.admin_url('admin-ajax.php').'", "plugin_url": "'.plugin_dir_url( __FILE__ ).'", "next_page": ""
		};
		/* ]]> */
		</script>';
		
	    ?>
	    <script type="text/javascript">
	    my_onload_callback = function() {
	    	<?php echo $GLOBALS['fb_wpress_pages_js_on_ready']; ?>
	    };
		
	    if( typeof jQuery == "function" ) { 
	        jQuery(my_onload_callback); // document.ready
	    }
	    else {
	        document.getElementsByTagName('body')[0].onload = my_onload_callback; // body.onload
	    }
	    
	    </script>
	    <?php
	}
	
	/*
	AJAX
	*/
	
	function fb_wpress_pages_listener() {
		$method = $_POST['method'];
		
		if($method=='disconnect') {
			$f1 = new Facebook_wpress_pages_settings();
			$f1->disconnect_user();
		}
		else if($method=='display_posts') {
			$url = urldecode($_POST['url']);
			
			$f1 = new Facebook_wpress_pages_display();
			$display = $f1->get_fb_feeds($url);
			$display = json_encode($display);
			echo $display;
		}
		else if($method=='display_comments') {
			//$url = $_POST['url'];
			
			$criteria = stripslashes($_POST['criteria']);
			$criteria = json_decode($criteria,true);
			$ftype = $criteria['ftype'];
			$url = $criteria['url'];
			
			$options = get_option(FACEBOOK_WPRESS_PAGES_SETTINGS);
			$token = $options['fb_token'];
			
			$resourceid = $criteria['resourceid'];
			$collapse = $criteria['collapse'];
			$nb_comments = $criteria['commentCount'];
			
			if(isset($_POST['url'])) $url = $_POST['url'];
			
			$y1 = new ybFacebook_listener_class_wpress_pages();
			$criteria2['id'] = $resourceid;
			$criteria2['url'] = $url;
			$criteria2['token'] = $token;
			$comments = $y1->getFacebookComments($criteria2);
			
			$criteria3['resourceid'] = $resourceid;
			$criteria3['commentCount'] = $nb_comments;
			$criteria3['comments'] = $comments['comments'];
			$criteria3['previous'] = $comments['previous_paging'];
			$criteria3['next'] = $comments['next_paging'];
			$criteria3['collapse'] = $collapse;
			
			$d1 = new ybFacebook_view_class_wpress_pages();
			echo $d1->displayComments($criteria3);
		}
		
		exit;
	}
	
}

new Facebook_wpress_pages();

?>