<?php

class Facebook_wpress_pages_settings extends WPress_framework_facebook_wpress_pages {
	
	function Facebook_wpress_pages_settings() {
		add_filter( 'plugin_action_links', array(__CLASS__, 'plugin_action_links'), 10, 2);
		add_action( 'admin_menu', array(__CLASS__, 'config_page_init') );
		add_action('admin_print_scripts', array(__CLASS__,'config_page_scripts'));
	}
	
	function config_page_scripts() {
		wp_enqueue_script('dashboard');
	    if (is_admin()) {
	    	//jQuery
	        //wp_deregister_script('jquery');
	        wp_register_script('jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.6/jquery.min.js');
	        wp_enqueue_script('jquery');
	        //Facebook SDK
	        wp_deregister_script('fb_pages_script');
	        wp_register_script('fb_pages_script', plugin_dir_url( __FILE__ ).'include/js/script.js');
	        wp_enqueue_script('fb_pages_script');
	    }
	}
	
	function config_page_init() {
		if (function_exists('add_submenu_page')) {
			add_submenu_page('plugins.php', 'Facebook Pages', 'Facebook Pages', 'manage_options', 'facebook-wpress-pages-config', array(__CLASS__, 'config_page_display'));
		}
	}
	
	function config_page_display() {
		
		$options = get_option(FACEBOOK_WPRESS_PAGES_SETTINGS);
		$fb_token = $options['fb_token'];
		
		$f1 = new Facebook_class_wpress_pages($options['fb_app_id'], $options['fb_app_secret']);
		$f1->loadJsSDK();
		
		//$data = $f1->getUserData();
		//print_r($data);
		
		echo '<script>
		/* <![CDATA[ */
		var Fb_wpress_pages = {
			"ajaxurl": "'.admin_url('admin-ajax.php').'"
		};
		/* ]]> */
		</script>';
		
		if($fb_token=='') {
			$data = $f1->getUserData();
			if($data['token']!='') {
				$options['fb_token'] = $data['token'];
				$options['fb_id'] = $data['id'];
				$options['fb_name'] = $data['name'];
				update_option(FACEBOOK_WPRESS_PAGES_SETTINGS, $options);
				//refresh variable values
				$options = get_option(FACEBOOK_WPRESS_PAGES_SETTINGS);
				$fb_token = $options['fb_token'];
			}
		}
		
		?>
		
		<div class="wrap">
		<div class="metabox-holder">
		
			<br>
			<?php
			echo '<a href="http://yougapi.com"><img src="'.plugin_dir_url( __FILE__ ).'include/graph/facebook-wpress-pages-mini.png" align="left" style="margin-right:15px;" /></a>';
			?>
			<h2>Facebook WPress Pages configuration</h2>
			<hr style="background:#ddd;color:#ddd;height:1px;border:none;">
			<br><br>
			
			<table width="100%"><tr>
			
			<td width="50%" valign="top">
			
			<?php
			//facebook app data
			$criteria['key'] = FACEBOOK_WPRESS_PAGES_SETTINGS;
			$criteria['box_title'] = 'Your Facebook application data';
			$criteria['fields'][] = array('name'=>'fb_app_id', 'title'=>'Facebook application id');
			$criteria['fields'][] = array('name'=>'fb_app_secret', 'title'=>'Facebook application secret');
			$criteria['fields'][] = array('name'=>'fb_like_button', 'title'=>'Display the Facebook Like/Send button with the Facebook pages <small>(Recommended to get more Fans)</small>', 'type'=>'checkbox');
			parent::display_admin_control($criteria);
			
			echo '<div class="meta-box-sortables">';
				echo '<div class="postbox" style="width:100%;">';
				echo '<div class="handlediv" title="Click to toggle"><br /></div>';
				echo '<h3 class="hndle"><span>Pages feeds & connection status</span></h3>';
				echo '<div class="inside" style="width:95%; padding:10px;">';
				
				if($fb_token=='') {
					echo '<p>You need to connect with your Facebook account before being able to display pages feeds.</p>';
					echo '<p><a id="fb_wpress_pages_fb_login" href="#"><img src="'.plugin_dir_url( __FILE__ ).'include/graph/facebook_connect.png" /></a></p>';
				}
				else {
					//<a href="http://www.facebook.com/profile.php?id='.$options['fb_id'].'" target="_blank">
					echo '<div style="overflow:hidden;">';
						
						echo '<div style="float:left; margin-right:10px;"><img src="http://graph.facebook.com/'.$options['fb_id'].'/picture" style="width:36px;"></div>';
						
						echo '<div style="float:left; overflow:hidden;">';
						echo '<p>Connected as '.$options['fb_name'].' (<a id="fb_wpress_pages_fb_logout" href="#">Disconnect</a>)</p>';
						echo '<p>The pages feeds should be able to load properly.</p>';
						echo '</div>';
						
					echo '</div>';
				}
				
				echo '</div>';
				echo '</div>';
			echo '</div>';
			
			?>
			
			<small>Plugin created by <a href="http://yougapi.com">Yougapi Technology</a></small>
			
			</td>
			
			<td style="padding-left:20px;" valign="top">
			
				<?php
				echo '<div class="meta-box-sortables">';
					echo '<div class="postbox" style="width:100%;">';
					echo '<div class="handlediv" title="Click to toggle"><br /></div>';
					echo '<h3 class="hndle"><span>My pages</span></h3>';
					echo '<div class="inside" style="width:95%; padding:10px;">';
					
					if($fb_token=='') {
						echo '<p>You need to connect with your Facebook account before being able to view your pages list.</p>';
						echo '<p><a id="fb_wpress_pages_fb_login" href="#"><img src="'.plugin_dir_url( __FILE__ ).'include/graph/facebook_connect.png" /></a></p>';
					}
					else {
						echo '<div>';
						$accounts_list = $f1->getFacebookAccounts($fb_token);
						$accounts_list = $accounts_list['data'];
						for($i=0; $i<count($accounts_list); $i++) { 
							if($accounts_list[$i]['category']!='Application') {
								echo '<p> - <a href="http://www.facebook.com/profile.php?id='.$accounts_list[$i]['id'].'" target="_blank">'.$accounts_list[$i]['name'].'</a> <small>(id: '.$accounts_list[$i]['id'].')</small></p>';
							}
						}
						if(count($accounts_list)==0) echo '<p>No page has been found.</p>';
						echo '</div>';
					}
					
					echo '</div>';
					echo '</div>';
				echo '</div>';
				?>
			
			</td>
			
			</tr></table>
			
		</div></div>
			
		<?php
	}
	
	function plugin_action_links($links, $file) {
		if ( $file == plugin_basename( dirname(__FILE__).'/facebook_wpress_pages.php' ) ) {
			$links[] = '<a href="plugins.php?page=facebook-wpress-pages-config">Settings</a>';
		}
		return $links;
	}
	
	//disconnect user
	function disconnect_user() {
		$options = get_option(FACEBOOK_WPRESS_PAGES_SETTINGS);
		$options['fb_token'] = '';
		$options['fb_id'] = '';
		$options['fb_name'] = '';
		update_option(FACEBOOK_WPRESS_PAGES_SETTINGS, $options);
		
		$f1 = new Facebook_class_wpress_pages($options['fb_app_id'], $options['fb_app_secret']);
		$cookie = $f1->getCookie();
		if($cookie!='') {
			echo '1';
		}
	}
}

new Facebook_wpress_pages_settings();

?>