<?php

class Facebook_class_wpress_pages
{
	var $fb_app_id;
	var $fb_secret;
	var $cookie;
	
	
	function Facebook_class_wpress_pages($fb_app_id='', $fb_secret='') {
		$this->fb_app_id = $fb_app_id;
		$this->fb_secret = $fb_secret;
		$this->cookie = $this->get_facebook_cookie($this->fb_app_id, $this->fb_secret);
	}
	
	function getDataFromUrl($url) {
		$ch = curl_init();
		$timeout = 5;
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
		$data = curl_exec($ch);
		curl_close($ch);
		return $data;
	}
	
	function getUserid() {
		$cookie = $this->getCookie();
		$fb_userid = $cookie['uid'];
		return $fb_userid;
	}
	
	function getProfilePicture() {
		$url = 'https://graph.facebook.com/'.$this->getUserid().'/picture?type=large';
		//$url = 'api.facebook.com/method/fql.query?query=SELECT pic_big FROM user WHERE uid = '.$this->getUserid();
		//$url = $this->get_redirect_url($url);
		return $url;
	}
	
	function getUserData() {
		$fb_cookie = $this->getCookie();
		if($fb_cookie) {
			$url = 'https://graph.facebook.com/me?access_token='.$this->getAccessToken();
			$data = json_decode($this->getDataFromUrl($url));
			$fb['id'] = $data->id;
			$fb['name'] = $data->name;
			$fb['first_name'] = $data->first_name;
			$fb['last_name'] = $data->last_name;
			$fb['link'] = $data->link;
			$fb['birthday'] = $data->birthday;
			$fb['gender'] = $data->gender;
			$fb['email'] = $data->email;
			$fb['timezone'] = $data->timezone;
			$fb['locale'] = $data->locale;
			$fb['updated_time'] = $data->updated_time;
			$fb['picture'] = $this->getProfilePicture();
			//tokens
			$fb['token'] = $fb_cookie['access_token'];
			$fb['token_expires'] = $fb_cookie['expires'];
			return $fb;
		}
	}
	
	function getCookie() {
		return $this->cookie;
	}
	
	function getAccessToken() {
		return $this->cookie['access_token'];
	}
	
	function loadJsSDK() {
		echo '<div id="fb-root"></div>';
		echo '<script>';
		
		echo 'window.fbAsyncInit = function() {';
		echo 'FB.init({appId: '.$this->fb_app_id.', status: true, cookie: true, xfbml: true});';
		echo '};';
		  
		echo '(function() {';
			echo 'var e = document.createElement(\'script\'); e.async = true;';
		    echo 'e.src = document.location.protocol +';
		    echo '\'//connect.facebook.net/en_US/all.js\';';
		    echo 'document.getElementById(\'fb-root\').appendChild(e);';
		echo '}());';
		  
		echo '</script>';
	}
	
	function get_facebook_cookie($app_id, $application_secret) {
	  $args = array();
	  parse_str(trim($_COOKIE['fbs_' . $app_id], '\\"'), $args);
	  ksort($args);
	  $payload = '';
	  foreach ($args as $key => $value) {
	    if ($key != 'sig') {
	      $payload .= $key . '=' . $value;
	    }
	  }
	  if (md5($payload . $application_secret) != $args['sig']) {
	    return null;
	  }
	  return $args;
	}
	
	function get_redirect_url($url) {
		$redirect_url = null; 
	 
		$url_parts = @parse_url($url);
		if (!$url_parts) return false;
		if (!isset($url_parts['host'])) return false; //can't process relative URLs
		if (!isset($url_parts['path'])) $url_parts['path'] = '/';
	 
		$sock = fsockopen($url_parts['host'], (isset($url_parts['port']) ? (int)$url_parts['port'] : 80), $errno, $errstr, 30);
		if (!$sock) return false;
	 
		$request = "HEAD " . $url_parts['path'] . (isset($url_parts['query']) ? '?'.$url_parts['query'] : '') . " HTTP/1.1\r\n"; 
		$request .= 'Host: ' . $url_parts['host'] . "\r\n"; 
		$request .= "Connection: Close\r\n\r\n"; 
		fwrite($sock, $request);
		$response = '';
		while(!feof($sock)) $response .= fread($sock, 8192);
		fclose($sock);
	 
		if (preg_match('/^Location: (.+?)$/m', $response, $matches)){
			if ( substr($matches[1], 0, 1) == "/" )
				return $url_parts['scheme'] . "://" . $url_parts['host'] . trim($matches[1]);
			else
				return trim($matches[1]);
	 
		} else {
			return false;
		}
	}
	
	function getFacebookAccounts($token) {
		$url = 'https://graph.facebook.com/me/accounts?access_token='.$token;
		$content = $this->getDataFromUrl($url,0,null,null);
		$content = json_decode($content,true);
		return $content;
	}
	
}

?>