<?php

class ybFacebook_listener_class_wpress_pages
{
	
	function getDataFromUrl($url) {
		$ch = curl_init();
		$timeout = 5;
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
		$data = curl_exec($ch);
		curl_close($ch);
		return $data;
	}
	
	function getFacebookFeeds($criteria) {
		$token = $criteria['token'];
		$userid = $criteria['userid'];
		$url = $criteria['url'];
		$ftype = $criteria['ftype'];
		
		if($userid=='') $userid = $this->facebook_userid;
		if($token=='') $token = $this->facebook_access_token;
		//if($ftype=='') $ftype = 'feed'; //home, feed, posts
		
		if($userid=='') $userid='me';
		
		if($url=='') $url = 'https://graph.facebook.com/'.$userid.'/'.$ftype.'?access_token='.$token;
		
		$data = $this->getDataFromUrl($url);
		$data = json_decode($data,true);
		
		return $data;
	}
	
	function formatFacebookPages($content) {
		for($i=0; $i<count($content['data']); $i++) {
			$id = $content['data'][$i]['id'];
			$name = $content['data'][$i]['name'];
			$category = $content['data'][$i]['category'];
			
			$picture = 'https://graph.facebook.com/'.$id.'/picture?type=square'; //square, small, large
			$url = 'http://www.facebook.com/profile.php?id='.$id;
			
			$pages[$i]['id'] = $id;
			$pages[$i]['name'] = $name;
			$pages[$i]['picture'] = $picture;
			$pages[$i]['url'] = $url;
			$pages[$i]['category'] = $category;
		}
		return $pages;
	}
	
	function postComment($post_id,$comment,$token) {
		$f1 = new yb_params_class();
		
		$facebook_access_token = $token;
		
		if($facebook_access_token!='') {
			$postParms = "access_token=".$facebook_access_token."&message=".$comment;
			//execute post
			$ch = curl_init('https://graph.facebook.com/'.$post_id.'/comments');
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $postParms);
			$result = curl_exec($ch);
			curl_close($ch);
			
		}
		return $result;
	}
	
	// ################################
	// ################# START Comments
	
	function getFacebookComments($criteria) {
		$id = $criteria['id'];
		$url = $criteria['url'];
		$token = $criteria['token'];
		
		if($token=='') $token = $this->facebook_access_token;
		
		if($url=='') {
			$url = 'https://graph.facebook.com/'.$id.'/comments?access_token='.$token.'';
		}
		$url = urldecode($url);
		
		$data = $this->getDataFromUrl($url);
		
		$data = json_decode($data,true);
		
		$previous_paging = urlencode($data['paging']['previous']);
		$next_paging = urlencode($data['paging']['next']);
		$commentsList = $this->formatFacebookComments($data);
		
		$comments['comments'] = $commentsList;
		$comments['nb'] = count($commentsList);
		$comments['previous_paging'] = $previous_paging;
		$comments['next_paging'] = $next_paging;
		
		return $comments;
	}
	
	function formatFacebookComments($data) {
		
		$gc1 = new ybGeneral_functions_class_wpress_pages();
		
		if(count($data['data'])>0) {
			$i=count($data['data']);
			foreach($data['data'] as $value) {
				$id = $value['id'];
				$from_id = $value['from']['id'];
				$from_name = $value['from']['name'];
				$message = $value['message'];
				$created = $value['created_time'];
				
				$created = $gc1->convertIso8601DateToTimestamp($created);
				//$created = $created-14400; //14400 = 4 hours
				$created = date('Y-m-d H:i:s', $created);
				
				$profile_url = 'http://www.facebook.com/profile.php?id='.$from_id;
				$picture = 'https://graph.facebook.com/'.$from_id.'/picture?access_token='.$this->facebook_access_token;
				
				$comments[$i]['id'] = $id;
				$comments[$i]['from_id'] = $from_id;
				$comments[$i]['name'] = $from_name;
				$comments[$i]['picture'] = $picture;
				$comments[$i]['profile_url'] = $profile_url;
				$comments[$i]['message'] = $message;
				$comments[$i]['created'] = $created;
				$i--;
			}
			arsort($comments);
		}
		return $comments;
	}
	
	function formatFacebookPosts($data) {
		
		$gc1 = new ybGeneral_functions_class_wpress_pages();
		
		for($i=0; $i<count($data['data']); $i++) {
			$id = $data['data'][$i]['id'];
			$from_id = $data['data'][$i]['from']['id'];
			$from_name = $data['data'][$i]['from']['name'];
			
			$type = $data['data'][$i]['type']; //video, link, status, picture, swf
			$message = $data['data'][$i]['message'];
			$picture = $data['data'][$i]['picture'];
			$link = $data['data'][$i]['link'];
			$source = $data['data'][$i]['source']; //for videos
			$name = $data['data'][$i]['name']; //for videos or links
			$caption = $data['data'][$i]['caption']; //for videos (domain name url) or links
			$description = $data['data'][$i]['description']; //for videos
			$icon = $data['data'][$i]['icon'];
			$created = $data['data'][$i]['created_time'];
			$likes_nb = $data['data'][$i]['likes'];
			
			$comments = $data['data'][$i]['comments']['data']; //(message, created_time)
			$comments_nb = $data['data'][$i]['comments']['count'];
			$action_comment = $data['data'][$i]['actions'][0]['link'];
			
			$picture_url = 'https://graph.facebook.com/'.$from_id.'/picture';
			$profile_url = 'http://www.facebook.com/profile.php?id='.$from_id;
			
			$created = $gc1->convertIso8601DateToTimestamp($created);
			//$today = time()-date('Z');
			//$created = $today-$created;
			//$created = $created+date('Z');
			
			//$created = $created-14400; //14400 = 4 hours
			
			//$created = $gc1->time_since($created,$today);
			$created = date('Y-m-d H:i:s', $created);
			//$created = $created.' - '.$today;
			
			$attribution = $data['data'][$i]['attribution'];
			
			$dataList[$i]['id'] = $id;
			$dataList[$i]['from_id'] = $from_id;
			$dataList[$i]['from_name'] = $from_name;
			$dataList[$i]['type'] = $type;
			$dataList[$i]['message'] = $message;
			$dataList[$i]['picture'] = $picture;
			$dataList[$i]['link'] = $link;
			$dataList[$i]['source'] = $source;
			$dataList[$i]['name'] = $name;
			$dataList[$i]['caption'] = $caption;
			$dataList[$i]['description'] = $description;
			$dataList[$i]['icon'] = $icon;
			$dataList[$i]['created'] = $created;
			$dataList[$i]['attribution'] = $attribution;
			$dataList[$i]['likes_nb'] = $likes_nb;
			$dataList[$i]['comments'] = $comments;
			$dataList[$i]['comments_nb'] = $comments_nb;
			$dataList[$i]['action_comment'] = $action_comment;
			$dataList[$i]['picture_url'] = $picture_url;
			$dataList[$i]['profile_url'] = $profile_url;
		}
		return $dataList;
	}
	
	function updateFacebookStatus($criteria, $token='') {
		$fb_id = $criteria['fb_id'];
		$message = $criteria['message'];
		$link = $criteria['link'];
		$picture = $criteria['picture'];
		$name = $criteria['name'];
		$caption = $criteria['caption'];
		$description = $criteria['description'];
		$source = $criteria['source'];
		
		if($fb_id=='') $fb_id = 'me';
		
		$criteriaString = '&message='.$message;
		if($link!='') $criteriaString .= '&link='.$link;
		if($picture!='') $criteriaString .= '&picture='.$picture;
		if($name!='') $criteriaString .= '&name='.$name;
		if($caption!='') $criteriaString .= '&caption='.$caption;
		if($description!='') $criteriaString .= '&description='.$description;
		if($source!='') $criteriaString .= '&source='.$source;
		
		if($token=='') $token = $this->facebook_access_token;
		$postParms = "access_token=".$token.$criteriaString;
		
		$ch = curl_init('https://graph.facebook.com/'.$fb_id.'/feed');
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_HEADER, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $postParms);
		$results = curl_exec($ch);
		curl_close($ch);
		return $results;
	}
}

?>