<?php 
/*
Plugin Name: WP Review Stars Premium
Plugin URI: http://wpreviewstars.com
Description: Inserts rich snippet review stars and reviews (2 widgets + 2 shortcodes)
Version: 1.0
Author: James Pate
Author URI: http://wpreviewstars.com
License: see license file.

see license.txt for more info.


see readme.txt for more info


*/


//------------------------SHORTCODE-------------------------//


 
 
 
 //[stars]
function jfp_stars_func( $atts, $options, $jfp_wp_reviewstars_premium ) {
$options = get_option('jfp_wp_reviewstars_premium');
if ($options['starimages'] == true ) {
 return '<img src="/wp-content/plugins/wp-reviewstars-premium/stars.png" style="width:' . $options['starwidth'] . 'px !important;" /><p class="hreview"</p> <p><span class="hreview-aggregate" ><span class="item"><span class="fn">Rating: </span></span><span class="rating"><em><span class="average">' . $options['rating'] . '</span> out of <span class="best">10</span> based on <span class="count">' . $options['reviews'] . '</span> ratings</em></span></span></p>';
	 }

else {
return '<p><span class="hreview-aggregate" ><span class="item"><span class="fn">Rating: </span></span><span class="rating"><em><span class="average">' . $options['rating'] . '</span> out of <span class="best">10</span> based on <span class="count">' . $options['reviews'] . '</span> ratings</em></span></span></p>';
}

	 
 
}
add_shortcode( 'stars', 'jfp_stars_func' );
 
 
 
 
 //------------------------------ADMIN--------------------------------//

add_action('admin_init', 'jfp_wp_reviewstars_premium_init' );
add_action('admin_menu', 'jfp_wp_reviewstars_premium_add_page');

// Init plugin options to white list our options
function jfp_wp_reviewstars_premium_init(){
	register_setting( 'jfp_wp_reviewstars_premium_options', 'jfp_wp_reviewstars_premium', 'jfp_wp_reviewstars_premium_validate' );
}

// Add menu page
function jfp_wp_reviewstars_premium_add_page() {
	add_options_page('WP Review Stars', 'WP Review Stars', 'manage_options', 'jfp_wp_reviewstars_premium', 'jfp_wp_reviewstars_premium_do_page');
}

// Draw the menu page itself
function jfp_wp_reviewstars_premium_do_page() {
	?>
	<div class="wrap">
		<h2>WP Review Stars Shortcode Settings</h2>
		<form method="post" action="options.php">
			<?php settings_fields('jfp_wp_reviewstars_premium_options'); ?>
			<?php $options = get_option('jfp_wp_reviewstars_premium'); ?>
			<table class="form-table">
				<tr valign="top"><th scope="row">Include Stars Image?</th>
					<td><input name="jfp_wp_reviewstars_premium[starimages]" type="checkbox" value="1" <?php checked('1', $options['starimages']); ?> /></td>
				</tr>

             			   <tr valign="top"><th scope="row">Star Images Width (Default is 250)</th>
					<td><input type="text" name="jfp_wp_reviewstars_premium[starwidth]" value="<?php echo $options['starwidth']; ?>" />px</td>
				</tr>
				<tr valign="top"><th scope="row">Rating out of 10</th>
					<td><input type="text" name="jfp_wp_reviewstars_premium[rating]" value="<?php echo $options['rating']; ?>" /></td>
				</tr>
                <tr valign="top"><th scope="row">Review Count</th>
					<td><input type="text" name="jfp_wp_reviewstars_premium[reviews]" value="<?php echo $options['reviews']; ?>" /></td>
				</tr>
                <tr valign="top"><th scope="row">Paypal Transaction ID: </th>
					<td><input type="text" name="jfp_wp_reviewstars_premium[paypal]" value="<?php echo $options['paypal']; ?>" /></td>
				</tr>
			</table>
       			 <p>Use the shortcode [stars] to insert star reviews into content.</p>
<h2>Ratable Stars Shortcode Settings</h2>
			<table>
				<tr valign="top"><th scope="row">Ratable Single Star Images Width(Default is 25)</th>
					<td><input type="text" name="jfp_wp_reviewstars_premium[sstarwidth]" value="<?php echo $options['sstarwidth']; ?>" />px</td>
				</tr>
			</table>
			<p>Use Shortcode [starrating] to insert into page.  Use custom field "count" and "rating" to set starting review count and avg rating (without quotes).  To set custom fields, edit the page where you want the review stars, and then make sure that custom fields are enabled first by going to screen options (top right of page) and checking custom fields.  After that, scroll down to the custom fields box and add 2 new custom fields "count" and "rating" with whatever number you want them initially set to.  
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>


	</div>
	<?php	
}

// Sanitize and validate input. Accepts an array, return a sanitized array.
function jfp_wp_reviewstars_premium_validate($input) {
	// Our first value is either 0 or 1
	$input['starimages'] = ( $input['starimages'] == 1 ? 1 : 0 );
	
	// Say our second option must be safe text with no HTML tags
	$input['starwidth'] =  wp_filter_nohtml_kses($input['starwidth']);




	// Say our third option must be safe text with no HTML tags
	$input['rating'] =  wp_filter_nohtml_kses($input['rating']);
	
	// Say our fourth option must be safe text with no HTML tags
	$input['reviews'] =  wp_filter_nohtml_kses($input['reviews']);
	
	// Our fifth value is either 0 or 1
	$input['activateincrease'] = ( $input['activateincrease'] == 1 ? 1 : 0 );
	
	// Say our third option must be safe text with no HTML tags
	$input['increaseamount'] =  wp_filter_nohtml_kses($input['increaseamount']);
	
	// Say our fourth option must be safe text with no HTML tags
	$input['schedules'] =  wp_filter_nohtml_kses($input['schedules']);
	
	$input['paypal'] =  wp_filter_nohtml_kses($input['paypal']);
	return $input;
}


 
//---------------------------WIDGETS----------------------------//

// execute function jfp_reviewstars_premium_register_widgets

add_action( 'widgets_init', 'jfp_reviewstars_premium_register_widgets' );

 //register our widget
function jfp_reviewstars_premium_register_widgets() {
    register_widget( 'jfp_reviewstars_premium_review' );
	register_widget( 'jfp_reviewstars_premium_stars' );
	register_widget( 'jfp_reviewstars_premium_nonsnippet_review' );
}


//=====jfp_reviewstars_premium_review widget code:==========//


//jfp_reviewstars_premium_review class
class jfp_reviewstars_premium_review extends WP_Widget {

    //process the new widget
    function jfp_reviewstars_premium_review() {
        $widget_ops = array( 
			'classname' => 'jfp_reviewstars_premium_review_class', 
			'description' => 'Displays a rich snippet review in a widget area.' 
			); 
        $this->WP_Widget( 'jfp_reviewstars_premium_review', 'WP Review Stars - Reviews', $widget_ops );
    }
 
    //build the widget settings form
    function form($instance) {
        $defaults = array( 'title' => 'Reviews', 'business' => '', 'review' => '', 'reviewer' => '', 'location' => '', 'color' => 'black'); 
        $instance = wp_parse_args( (array) $instance, $defaults );
        $title = $instance['title'];
	    $business = $instance['business'];
        $review = $instance['review'];
		$reviewer = $instance['reviewer'];
		$location = $instance['location'];
		$color = $instance['color'];

        ?>
            <p>Title: <input class="widefat" name="<?php echo $this->get_field_name( 'title' ); ?>"  type="text" value="<?php echo esc_attr( $title ); ?>" /></p>
		    <p>Business: <input class="widefat" name="<?php echo $this->get_field_name( 'business' ); ?>"  type="text" value="<?php echo esc_attr( $business ); ?>" /></p>
            <p>Review: <textarea class="widefat" name="<?php echo $this->get_field_name( 'review' ); ?>" / ><?php echo esc_attr( $review ); ?></textarea></p>
            <p>Reviewer: <input class="widefat" name="<?php echo $this->get_field_name( 'reviewer' ); ?>" value="<?php echo esc_attr( $reviewer ); ?>" /></p>
            <p>Location/Other meta info that shows in Google: <input class="widefat" name="<?php echo $this->get_field_name( 'location' ); ?>" value="<?php echo esc_attr( $location ); ?>" /></p>
 			<p>Font Color: <input class="widefat" name="<?php echo $this->get_field_name( 'color' ); ?>" value="<?php echo esc_attr( $color ); ?>" /></p>
			<p>NOTE: To add additional Review widgets on the same page, use the NONsnippet review widget that doesnt use rich snippets or Google will not pick up anything!</p>
            
        <?php
    }
 
    //save the widget settings
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags( $new_instance['title'] );
		$instance['business'] = strip_tags( $new_instance['business'] );
		$instance['review'] = strip_tags( $new_instance['review'] );      
        $instance['reviewer'] = strip_tags( $new_instance['reviewer'] );
        $instance['location'] = strip_tags( $new_instance['location'] );
		$instance['color'] = strip_tags( $new_instance['color'] );
        return $instance;
    }
 
    //display the widget
    function widget($args, $instance) {
        extract($args);
 
        echo $before_widget;
        $title = apply_filters( 'widget_title', $instance['title'] );
		$business = empty( $instance['business'] ) ? '&nbsp;' : $instance['business']; 
        $review = empty( $instance['review'] ) ? '&nbsp;' : $instance['review'];
		$name = empty( $instance['reviewer'] ) ? '&nbsp;' : $instance['reviewer']; 
		$location = empty( $instance['location'] ) ? '&nbsp;' : $instance['location']; 
		$color = empty( $instance['color'] ) ? '&nbsp;' : $instance['color'];
 
        if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
        echo '<div style="width:250px;display: block;margin-left: auto;margin-right: auto"><p itemscope itemtype="http://data-vocabulary.org/Review" style="font-style:italic;color:' . $color . ';font-size:' . $fsize . ';">
<img src="/wp-content/plugins/wp-reviewstars/lquote.png" style="float:left;">&nbsp;&nbsp;<span itemprop="summary">' . $review . '</span> <br><span itemprop="itemreviewed">' . $business . ' </span> Rating: <span itemprop="rating">5</span> out of 5.<br> &#8211; <span itemprop="reviewer">' . $name . ' &#8211; ' . $location . '</span><img src="/wp-content/plugins/wp-reviewstars/rquote.png" style="float:right;">

</p></div>';
    }
}


//=====jfp_reviewstars_premium_nonsnippet_review widget code:==========//


//jfp_reviewstars_premium_review class
class jfp_reviewstars_premium_nonsnippet_review extends WP_Widget {

    //process the new widget
    function jfp_reviewstars_premium_nonsnippet_review() {
        $widget_ops = array( 
			'classname' => 'jfp_reviewstars_premium_nonsnippet_review_class', 
			'description' => 'Displays a review in a widget area(without rich snippet formatting).' 
			); 
        $this->WP_Widget( 'jfp_reviewstars_premium_nonsnippet_review', 'WP Review Stars - Reviews W/O Snippets', $widget_ops );
    }
 
    //build the widget settings form
    function form($instance) {
        $defaults = array( 'title' => '', 'business' => '', 'review' => '', 'reviewer' => '', 'location' => '', 'color' => 'black'); 
        $instance = wp_parse_args( (array) $instance, $defaults );
        $title = $instance['title'];
	    $business = $instance['business'];
        $review = $instance['review'];
		$reviewer = $instance['reviewer'];
		$location = $instance['location'];
		$color = $instance['color'];

        ?>
            <p>Title: <input class="widefat" name="<?php echo $this->get_field_name( 'title' ); ?>"  type="text" value="<?php echo esc_attr( $title ); ?>" /></p>
		    <p>Business: <input class="widefat" name="<?php echo $this->get_field_name( 'business' ); ?>"  type="text" value="<?php echo esc_attr( $business ); ?>" /></p>
            <p>Review: <textarea class="widefat" name="<?php echo $this->get_field_name( 'review' ); ?>" / ><?php echo esc_attr( $review ); ?></textarea></p>
            <p>Reviewer: <input class="widefat" name="<?php echo $this->get_field_name( 'reviewer' ); ?>" value="<?php echo esc_attr( $reviewer ); ?>" /></p>
            <p>Location: <input class="widefat" name="<?php echo $this->get_field_name( 'location' ); ?>" value="<?php echo esc_attr( $location ); ?>" /></p>
 			<p>Font Color: <input class="widefat" name="<?php echo $this->get_field_name( 'color' ); ?>" value="<?php echo esc_attr( $color ); ?>" /></p>
            <p>NOTE: None of this info will show in Google, use this for adding additional reviews</p>

            
        <?php
    }
 
    //save the widget settings
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags( $new_instance['title'] );
		$instance['business'] = strip_tags( $new_instance['business'] );
		$instance['review'] = strip_tags( $new_instance['review'] );      
        $instance['reviewer'] = strip_tags( $new_instance['reviewer'] );
        $instance['location'] = strip_tags( $new_instance['location'] );
		$instance['color'] = strip_tags( $new_instance['color'] );
        return $instance;
    }
 
    //display the widget
    function widget($args, $instance) {
        extract($args);
 
        echo $before_widget;
        $title = apply_filters( 'widget_title', $instance['title'] );
		$business = empty( $instance['business'] ) ? '&nbsp;' : $instance['business']; 
        $review = empty( $instance['review'] ) ? '&nbsp;' : $instance['review'];
		$name = empty( $instance['reviewer'] ) ? '&nbsp;' : $instance['reviewer']; 
		$location = empty( $instance['location'] ) ? '&nbsp;' : $instance['location']; 
		$color = empty( $instance['color'] ) ? '&nbsp;' : $instance['color'];
 
        if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
          echo '<div style="font-style:italic;color:' . $color . ';font-size:' . $fsize . ';">
<img src="/wp-content/plugins/wp-reviewstars/lquote.png" style="float:left;">&nbsp;&nbsp;' . $review . ' <br>' . $business . ' Rating: 5 out of 5.<br> &#8211; ' . $name . ' &#8211; ' . $location . '<img src="/wp-content/plugins/wp-reviewstars/rquote.png" style="float:right;" />

</div>';
        echo $after_widget;
    }
}

// ===========jfp_wp_reviewstars_premium_stars==================


//jfp_reviewstars_premium_stars class
class jfp_reviewstars_premium_stars extends WP_Widget {

    //process the new widget
    function jfp_reviewstars_premium_stars() {
        $widget_ops = array( 
			'classname' => 'jfp_reviewstars_premium_stars_class', 
			'description' => 'Displays rich snippet star reviews in a widget area.' 
			); 
        $this->WP_Widget( 'jfp_reviewstars_premium_stars', 'WP Review Stars - Stars', $widget_ops );
    }
 
    //build the widget settings form
    function form($instance) {
        $defaults = array( 'title' => 'Rating', 'custom' => '', 'rating' => '10', 'reviews' => '5', 'color' => 'black', 'stars' => true, 'starwidth' => '200' ); 
        $instance = wp_parse_args( (array) $instance, $defaults );
        $title = $instance['title'];
	    $custom = $instance['custom'];
        $rating = $instance['rating'];
		$reviews = $instance['reviews'];
		$color = $instance['color'];
		$stars = isset( $instance['stars'] ) ? $instance['stars'] : false;
		$starwidth = $instance['starwidth'];

        ?>
            <p>Title: <input class="widefat" name="<?php echo $this->get_field_name( 'title' ); ?>"  type="text" value="<?php echo esc_attr( $title ); ?>" /></p>
            <p>Intro Text (optional): <textarea class="widefat" name="<?php echo $this->get_field_name( 'custom' ); ?>" / ><?php echo esc_attr( $custom ); ?></textarea></p>
            <p>Rating (out of 10): <input class="widefat" name="<?php echo $this->get_field_name( 'rating' ); ?>" value="<?php echo esc_attr( $rating ); ?>" /></p>
            <p>Total Reviews: <input class="widefat" name="<?php echo $this->get_field_name( 'reviews' ); ?>" value="<?php echo esc_attr( $reviews ); ?>" /></p>
            <p>Font Color: <input class="widefat" name="<?php echo $this->get_field_name( 'color' ); ?>" value="<?php echo esc_attr( $color ); ?>" /></p>
            
        <p>
			<input class="checkbox" type="checkbox" <?php checked( $instance['stars'], true ); ?> id="<?php echo $this->get_field_id( 'show_sex' ); ?>" name="<?php echo $this->get_field_name( 'stars' ); ?>" />
			<label for="<?php echo $this->get_field_id( 'stars' ); ?>">Display Star Graphics?</label>
	</p>
	<p>Stars Image Width: (default=200) <input class="widefat" name="<?php echo $this->get_field_name( 'starwidth' ); ?>" value="<?php echo esc_attr( $starwidth ); ?>" />px</p>
  
  
            
        <?php
		
	
    }

    //save the widget settings
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags( $new_instance['title'] );
		$instance['custom'] = strip_tags( $new_instance['custom'] );
		$instance['rating'] = strip_tags( $new_instance['rating'] );      
        $instance['reviews'] = strip_tags( $new_instance['reviews'] );
		$instance['color'] = strip_tags( $new_instance['color'] );
	$instance['stars'] = ( isset( $new_instance['stars'] ) ? 1 : 0 );  
	$instance['starwidth'] = strip_tags( $new_instance['starwidth'] ); 
        return $instance;
    }
 
    //display the widget
    function widget($args, $instance) {
        extract($args);
 
        echo $before_widget;
        $title = apply_filters( 'widget_title', $instance['title'] );
		$custom = empty( $instance['custom'] ) ? '&nbsp;' : $instance['custom']; 
        $rating = empty( $instance['rating'] ) ? '&nbsp;' : $instance['rating'];
		$reviews = empty( $instance['reviews'] ) ? '&nbsp;' : $instance['reviews'];
		$color = empty( $instance['color'] ) ? '&nbsp;' : $instance['color']; 
 		$stars = empty( $instance['stars'] ) ? '' : $instance['stars']; 
		$starwidth = empty( $instance['starwidth'] ) ? '&nbsp;' : $instance['starwidth']; 
        if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
		if ( $stars == true ) {
			 echo '<img src="/wp-content/plugins/wp-reviewstars-premium/stars.png" style="width:' . $starwidth . 'px !important ;text-align:center;" />';
			      };
        		echo '<br><p style="text-align:center;color:' . $color . ';">' . $custom . '</p><div class="hreview" style="color:' . $color . ';z-index:-5; width=1px;">
 <span class="hreview-aggregate" >
<span class="item"><span class="fn">Rating:</span>
</span>
<span class="rating"><em><span class="average">' . $rating . '</span> out of <span class="best">10</span> based on <span class="count">' . $reviews . '</span> ratings</em></span>
</span>
</div>';
        echo $after_widget;
    }
}

//------------------------------PREMIUM SHORTCODE---------------------------------//

//[starrating]
function jfp_starrating_func() {
global $wpdb;
global $post;
$rating = get_post_meta($post->ID, 'rating', true);
$count = get_post_meta($post->ID, 'count', true);
$options = get_option('jfp_wp_reviewstars_premium');
$updatepostmetaurl = plugins_url( 'updatepostmeta.php' , __FILE__ );
$ajaxurl = admin_url( 'admin-ajax.php' );
$scriptjsurl = plugins_url( 'script.js' , __FILE__ );
$postid = get_the_ID();
if (8.5 <= $rating && $rating < 9.5) {
$src10 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src9 = $src8 = $src7 = $src6 = $src5 = $src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (7.5 <= $rating && $rating < 8.5)
{
$src9 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src8 = $src7 = $src6 = $src5 = $src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (6.5 <= $rating && $rating < 7.5)
{
$src8 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = $src9 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src7 = $src6 = $src5 = $src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (5.5 <= $rating && $rating < 6.5)
{
$src7 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = $src9 = $src8 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src6 = $src5 = $src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (4.5 <= $rating && $rating < 5.5)
{
$src6 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = $src9 = $src8 = $src7 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src5 = $src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (3.5 <= $rating && $rating < 4.5)
{
$src5 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = $src9 = $src8 = $src7 = $src6 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (2.5 <= $rating && $rating < 3.5)
{
$src4 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = $src9 = $src8 = $src7 = $src6 = $src5 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (1.5 <= $rating && $rating < 2.5)
{
$src3 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = $src9 = $src8 = $src7 = $src6 = $src5 = $src4 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif (.5 <= $rating && $rating < 1.5)
{
$src2 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src10 = $src9 = $src8 = $src7 = $src6 = $src5 = $src4 = $src3 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
$src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}
elseif ($rating < .5)
{
$src10 = $src9 = $src8 = $src7 = $src6 = $src5 = $src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
}
else {
$src10 = $src9 = $src8 = $src7 = $src6 = $src5 = $src4 = $src3 = $src2 = $src1 = "/wp-content/plugins/wp-reviewstars-premium/star.png";
}

//ajaxphp
echo '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script><script type="text/javascript">

function starhover(thisid) {
document.getElementById(thisid).src="/wp-content/plugins/wp-reviewstars-premium/starhover.png";
}
function starout(thisid) {
document.getElementById(thisid).src="/wp-content/plugins/wp-reviewstars-premium/star.png";
}
function starup() {
document.getElementById(\'stargroup\').innerHTML=\'thank you for your vote!\';
}
function stardown(jthisid) {
document.getElementById(jthisid).src = "/wp-content/plugins/wp-reviewstars-premium/starclick.png";
var jpostid=document.getElementById(jthisid).className;
$.post("'. $updatepostmetaurl .'", { postid: jpostid, thisid : jthisid , rating: '. $rating .', count: '. $count .' });
document.getElementById(\'stargroup\').innerHTML=\'thank you for your vote!\';
}
</script>';
//end javascript
//begin images
return '<p id="stargroup">
<img class="'. $postid .'"  postid="'. $postid .'"onmouseup="starup()" onmousedown="stardown(1)"  onmouseover="starhover(1)" onmouseout="starout(1)" id="1" style="float:left;" src="' . $src1 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(2)"  onmouseover="starhover(2)" onmouseout="starout(2)" id="2" style="float:left;" src="' . $src2 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(3)"  onmouseover="starhover(3)" onmouseout="starout(3)" id="3" style="float:left;" src="' . $src3 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(4)"  onmouseover="starhover(4)" onmouseout="starout(4)" id="4" style="float:left;" src="' . $src4 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(5)"  onmouseover="starhover(5)" onmouseout="starout(5)" id="5" style="float:left;" src="' . $src5 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(6)"  onmouseover="starhover(6)" onmouseout="starout(6)" id="6" style="float:left;" src="' . $src6 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(7)"  onmouseover="starhover(7)" onmouseout="starout(7)" id="7" style="float:left;" src="' . $src7 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(8)"  onmouseover="starhover(8)" onmouseout="starout(8)" id="8" style="float:left;" src="' . $src8 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(9)"  onmouseover="starhover(9)" onmouseout="starout(9)" id="9" style="float:left;" src="' . $src9 . '" width="' . $options['sstarwidth'] . '" /><img class="'. $postid .'" postid="' . $postid . '" onmouseup="starup()" onmousedown="stardown(10)"  onmouseover="starhover(10)" onmouseout="starout(10)" id="10" src="' . $src10 . '" style="width:' . $options['sstarwidth'] . 'px !important;float:left" /><span class="hreview" style="z-index:-5;width=1px;"> <br><br><span class="hreview-aggregate" ><span class="item"><span class="fn">Rating: </span></span><span class="rating"><em><span class="average">' . $rating . '</span> out of <span class="best">10</span> based on <span class="count">' . $count . '</span> ratings</em></span></span></span></p>';
}
add_shortcode( 'starrating', 'jfp_starrating_func' );

?>